<script>
import Vue from 'vue';
import Tabs from './competition-landing-tabs.vue';
import CompetitionModal from './competition-modal.vue';

export default Vue.extend({
  components: {
    Tabs,
    CompetitionModal,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      headers: [],
      selectedTab: this.getPreSelectedTab(),
      baseImgUrl: '/nuxt-images/competition/progress-bars/',
      rowDescriptionStatus: [],
      modal: {
        open: false,
        header: '',
        competitors: [],
        percentages: [],
        description: null,
        stage: '',
        href: '',
      },
    };
  },
  watch: {
    modal: {
      handler(newValue) {
        if (newValue.open === true) {
          document.querySelector('body').classList.add('noScroll');
        } else {
          document.querySelector('body').classList.remove('noScroll');
        }
      },
      deep: true,
    },
  },
  mounted() {
    document.addEventListener('click', (e) => {
      if (this.modal.open && e.target.matches('.modal__backdrop')) {
        this.closeModal();
      }
    });
  },

  methods: {
    updateURL(index) {
      this.$router.push({
        path: '',

        query: {
          stage: this.data.tabs[index].header.text,
        },
      });
    },
    getPreSelectedTab() {
      const { stage } = this.$route.query;
      if (!stage) {
        return 0;
      }
      const selectedStage = this.data.tabs.findIndex(
        (tab) => tab.header.text.toLowerCase() === stage.toLowerCase(),
      );
      return selectedStage >= 0 ? selectedStage : 0;
    },

    setSelectedTab(value) {
      this.selectedTab = value;
      this.updateURL(value);
    },
    progressBarAltText(percent) {
      switch (percent) {
        case 0:
          return 'Progress bar that shows the current feature capability as little or no capability';
        case 25:
          return 'Progress bar that shows the current feature capability as basic';
        case 50:
          return 'Progress bar that shows the current feature capability as adequate';
        case 75:
          return 'Progress bar that shows the current feature capability as good';
        case 100:
          return 'Progress bar that shows the current feature capability as comprehensive';
        default:
          return null;
      }
    },
    openModal(label, competitors, percentages, description, href, stage) {
      this.modal.open = true;
      this.modal.header = label;
      this.modal.competitors = competitors;
      this.modal.percentages = {
        gitlab_progress: percentages.progress1,
        github_progress: percentages.progress2,
        bic_progress: percentages.progress3,
      };
      this.modal.description = description;
      this.modal.stage = stage;
      this.modal.href = `${href}?stage=${stage}&feature=${label}`;
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="tab-table" :tabindex="modal.open ? '-1' : null">
    <Tabs
      :data="data"
      :selected-tab="selectedTab"
      @tab-change="setSelectedTab"
    />
    <div
      :id="`${data.tabs[selectedTab].header.text}-panel`"
      class="tab-table__container"
      role="tabpanel"
      :aria-labelledby="`${data.tabs[selectedTab].header.text}-control`"
    >
      <div
        role="table"
        class="table"
        aria-describedby="table-description"
        aria-label="DevOps maturity comparison chart"
      >
        <div role="rowgroup" class="rowgroup" :aria-hidden="modal.open">
          <div role="row" class="row header-row">
            <span role="columnheader" class="header-feature">
              <SlpIcon
                class="icon"
                :name="data.tabs[selectedTab].header.text.toLowerCase()"
                variant="marketing"
                size="md"
              />
              <SlpTypography variant="heading5-bold">{{
                data.tabs[selectedTab].header.text
              }}</SlpTypography>
            </span>
            <span role="columnheader" class="header-company">
              <div class="flex">
                <SlpTypography variant="heading5-bold" class="company-name"
                  >GitLab</SlpTypography
                >
                <img
                  :src="`${baseImgUrl}${data.tabs[selectedTab].overview.gitlab_progress}.svg`"
                  :alt="
                    progressBarAltText(
                      data.tabs[selectedTab].overview.gitlab_progress,
                    )
                  "
                />
              </div>
            </span>
            <span
              v-for="(competitor, competitorIndex) in data.tabs[selectedTab]
                .competitors"
              :key="competitor.text"
              role="columnheader"
              class="header-company"
              :class="{ bordered: !competitorIndex }"
            >
              <div class="flex">
                <SlpTypography
                  variant="heading5-bold"
                  tag="span"
                  class="company-name"
                >
                  <SlpButton
                    v-if="competitor.href"
                    :href="competitor.href"
                    variant="tertiary"
                    :data-ga-name="`gitlab vs ${competitor.text}`"
                    data-ga-location="competition table overview"
                  >
                    {{ competitor.text }}
                    <SlpIcon
                      v-if="competitor.href"
                      class="learn-more-icon"
                      name="chevron-lg-right"
                      variant="product"
                    />
                  </SlpButton>
                  <span v-else>
                    {{ competitor.text }}
                  </span>
                </SlpTypography>
                <img
                  :src="`${baseImgUrl}${
                    competitor.text == 'GitHub'
                      ? data.tabs[selectedTab].overview.github_progress
                      : data.tabs[selectedTab].overview.bic_progress
                  }.svg`"
                  :alt="
                    progressBarAltText(
                      competitor.text == 'GitHub'
                        ? data.tabs[selectedTab].overview.github_progress
                        : data.tabs[selectedTab].overview.bic_progress,
                    )
                  "
                />
              </div>
            </span>
          </div>
          <div class="table-body">
            <div
              v-for="row in data.tabs[selectedTab].rows"
              :key="row.label"
              role="row"
              class="row"
            >
              <span role="cell" class="label">
                <button
                  :id="`${row.label}-modal-control`"
                  :aria-label="`opens dialog box containing more information about ${row.label}`"
                  type="button"
                  @click="
                    openModal(
                      row.label,
                      data.tabs[selectedTab].competitors,
                      row,
                      row.description,
                      data.tabs[selectedTab].competitors[
                        data.tabs[selectedTab].competitors.length - 1
                      ].href || data.tabs[selectedTab].competitors[0].href,
                      data.tabs[selectedTab].header.text,
                    )
                  "
                >
                  {{ row.label }}
                </button>
              </span>
              <span role="cell" class="progress">
                <div class="cell-container">
                  <SlpTypography variant="heading5-bold" class="mobile-label"
                    >GitLab</SlpTypography
                  >
                  <nuxt-img
                    width="90"
                    :src="`${baseImgUrl}${row.progress1}.svg`"
                    :alt="progressBarAltText(row.progress1)"
                  />
                </div>
              </span>
              <span role="cell" class="progress">
                <div class="cell-container">
                  <SlpButton
                    :href="data.tabs[selectedTab].competitors[0].href"
                    variant="tertiary"
                    :data-ga-name="`gitlab vs ${data.tabs[selectedTab].competitors[0].text}`"
                    data-ga-location="competition table mobile"
                    class="mobile-label"
                  >
                    {{ data.tabs[selectedTab].competitors[0].text }}
                    <SlpIcon
                      class="learn-more-icon"
                      name="chevron-right"
                      variant="product"
                    />
                  </SlpButton>
                  <img
                    :src="`${baseImgUrl}${row.progress2}.svg`"
                    :alt="progressBarAltText(row.progress2)"
                  />
                </div>
              </span>
              <span
                v-if="row.progress3 !== undefined"
                role="cell"
                class="progress"
              >
                <div class="cell-container">
                  <SlpButton
                    :href="data.tabs[selectedTab].competitors[1].href"
                    variant="tertiary"
                    :data-ga-name="`gitlab vs ${data.tabs[selectedTab].competitors[1].text}`"
                    data-ga-location="competition table mobile"
                    class="mobile-label"
                  >
                    {{ data.tabs[selectedTab].competitors[1].text }}
                    <SlpIcon
                      class="learn-more-icon"
                      name="chevron-right"
                      variant="product"
                    />
                  </SlpButton>
                  <img
                    :src="`${baseImgUrl}${row.progress3}.svg`"
                    :alt="progressBarAltText(row.progress3)"
                  />
                </div>
              </span>
            </div>
          </div>
        </div>
        <CompetitionModal
          v-if="modal.open"
          :visible="modal.open"
          :aria-modal="modal.open"
          :aria-hidden="!modal.open"
          light-background
          :aria-labelledby="`${modal.header}-modal-control`"
          @close="closeModal"
        >
          <template #body>
            <SlpContainer>
              <SlpTypography tabindex="0" variant="body1-bold" tag="h3">{{
                modal.header
              }}</SlpTypography>
              <div class="flex">
                <SlpTypography variant="body3-bold" tag="p"
                  >GitLab</SlpTypography
                >
                <img
                  :src="`${baseImgUrl}${modal.percentages.gitlab_progress}.svg`"
                  alt=""
                />
              </div>
              <div class="flex">
                <SlpTypography variant="body3-bold" tag="p"
                  >{{ modal.competitors[0].text }}
                </SlpTypography>
                <img
                  :src="`${baseImgUrl}${modal.percentages.github_progress}.svg`"
                  alt=""
                />
              </div>
              <div v-if="modal.competitors[1]" class="flex">
                <SlpTypography variant="body3-bold" tag="p"
                  >{{ modal.competitors[1].text }}
                </SlpTypography>
                <img
                  :src="`${baseImgUrl}${modal.percentages.bic_progress}.svg`"
                  alt=""
                />
              </div>
              <div>
                <SlpButton
                  variant="tertiary"
                  :href="modal.href"
                  class="modal-cta"
                  >Read in-depth analysis
                  <SlpIcon variant="product" name="chevron-lg-right"
                /></SlpButton>
              </div>
              <div
                class="description"
                v-html="$md.render(modal.description)"
              ></div>
            </SlpContainer>
          </template>
        </CompetitionModal>
      </div>
      <div class="table-cta">
        <SlpButton
          variant="tertiary"
          :href="`/direction/${data.tabs[
            selectedTab
          ].header.text.toLowerCase()}`"
          :data-ga-name="`${data.tabs[selectedTab].header.text} roadmap`"
          data-ga-location="competition table table roadmap cta"
        >
          Learn about GitLab's roadmap for
          {{ data.tabs[selectedTab].header.text }}
          <SlpIcon
            class="learn-more-icon"
            name="chevron-lg-right"
            variant="product"
          />
        </SlpButton>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.tab-table {
  margin-top: $spacing-32;
  margin-bottom: $spacing-48;
  box-shadow: $shadow-surface-primary-1;
  border: 1px solid $color-surface-200;
  border-radius: 8px;

  @media (max-width: $breakpoint-md) {
    box-shadow: none;
    border: none;
  }

  &__container {
    background: $color-surface-100;
    padding: $spacing-64 $spacing-96 $spacing-48 $spacing-96;

    @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
      padding: $spacing-64 $spacing-48 $spacing-48 $spacing-48;
    }

    @media (max-width: $breakpoint-md) {
      background: $color-surface-100;
      padding: 0 0 40px 0;
    }

    .table {
      position: relative;
      background: $color-surface-50;
      padding: $spacing-16 $spacing-48 0 $spacing-48;
      border-radius: 8px;
      @media (max-width: $breakpoint-md) {
        padding: 0;
      }

      .rowgroup {
        @media (max-width: $breakpoint-md) {
          background: $color-surface-100;
        }
      }

      .header-row {
        border-bottom: 1px solid $color-surface-200;
        @media (max-width: $breakpoint-md) {
          border-bottom: none;
          background: $color-surface-100;
          padding: $spacing-8 $spacing-24;
        }
      }

      .label {
        flex: 0 0 30%;

        button {
          padding-left: 0;
          border: none;
          font-size: 16px;
          line-height: 24px;
          font-weight: $font-weight-normal;
          text-decoration: underline;
          cursor: pointer;
          text-align: left;
          position: relative;
          color: $color-text-300;

          &:after {
            content: '';
            background-image: url('/nuxt-images/competition/arrow-angle.svg');
            background-repeat: no-repeat;
            position: absolute;
            top: 7px;
            right: -15px;
            width: 15px;
            height: 15px;
            display: none;
          }

          &:hover {
            &:after {
              display: block;
            }
          }
        }
      }
      .progress {
        text-align: left;
        width: 100%;

        @media (max-width: $breakpoint-md) {
          max-width: 90px;
          margin: 0;
        }
      }
    }

    span[role='columnheader'] {
      padding: $spacing-24 0;
      background: $color-surface-50;

      @media (max-width: $breakpoint-md) {
        padding: $spacing-8 0;
      }

      &.header-feature {
        display: flex;
        gap: $spacing-16;
        align-items: center;
        flex: 0 0 30%;
        padding-left: 0;
        text-align: left;

        @media (max-width: $breakpoint-md) {
          background: $color-surface-100;
        }
      }

      &.header-company {
        width: 100%;
        min-width: 150px;

        @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
          max-width: 120px;
          min-width: 100px;
        }

        @media (max-width: $breakpoint-md) {
          display: none;
        }

        .flex {
          display: flex;
          justify-content: center;
          flex-direction: column;
          align-items: center;

          @media (max-width: $breakpoint-md) {
            align-items: center;
          }

          img {
            width: 150px;

            @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
              width: 120px;
            }
          }

          .company-name {
            margin-bottom: $spacing-8;

            .slp-btn {
              display: flex;
              align-items: flex-start;
              padding: 0;
              font-size: 24px;
              line-height: 32px;
              font-weight: 600;
              letter-spacing: -0.6px;
            }

            .slp-btn .slp-icon {
              margin-left: 8px;
            }
          }
        }
      }
    }

    .table-body {
      @media (max-width: $breakpoint-md) {
        margin: $spacing-16;
        border-radius: 8px;
        background: $color-surface-50;
      }
    }

    .row {
      display: flex;
      align-items: center;
      flex-wrap: nowrap;
      position: relative;
      width: 100%;

      &:not(.header-row) {
        border-bottom: 1px solid $color-surface-200;
      }

      @media (max-width: $breakpoint-md) {
        flex-wrap: wrap;
        justify-content: space-between;
        margin: 0 auto;

        &:not(.header-row) {
          padding: $spacing-16;
        }
      }
      span[role='cell'] {
        display: block;
        text-align: left;
        padding: $spacing-32 0;

        &:first-of-type {
          padding-left: 0;
        }

        @media (max-width: $breakpoint-md) {
          &:not(.label) {
            flex: 1 0 100%;
            padding: $spacing-24 0;
          }

          &.label {
            width: 100%;
            flex: 1 0 100%;
            padding: 0;
          }
        }

        .cell-container {
          display: flex;
          justify-content: center;
          align-items: center;

          @media (max-width: $breakpoint-md) {
            flex-direction: column;
            text-align: left;
            align-items: flex-start;
            min-width: 85px;
            position: relative;

            img {
              width: 100%;
            }
            .mobile-label {
              margin-bottom: 4px;
              font-size: 16px;
              line-height: 20px;
              font-weight: bold;
              display: flex;
              flex-direction: row;
              padding: 0;
            }
          }
        }
      }
    }
  }

  .mobile-label {
    display: none;
    @media (max-width: $breakpoint-md) {
      display: block;
    }
  }

  .modal-cta {
    padding-left: 0;
  }

  .table-cta {
    background: $color-surface-50;
    padding: $spacing-48 $spacing-48 $spacing-48 $spacing-32;
    border-bottom-left-radius: 8px;
    border-bottom-right-radius: 8px;

    .slp-icon {
      margin-left: $spacing-8;
    }

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }
}
</style>
